/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service;

import com.ejie.ad74a.dao.AyuntamientosDao;
import com.ejie.ad74a.dao.UsuariosAyuntamientoDao;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.model.Ayuntamientos;
import com.ejie.ad74a.model.UnidadesBase;
import com.ejie.ad74a.model.UsuariosAyuntamiento;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.comun.UtilidadesFecha;
import com.ejie.ad74a.util.constantes.TipoUsuarioEnum;

/**
 * UsuariosAyuntamientoServiceImpl generated by UDA, 22-ago-2023 11:39:55.
 * 
 * @author UDA
 */

@Service(value = "usuariosAyuntamientoService")
public class UsuariosAyuntamientoServiceImpl implements UsuariosAyuntamientoService {

	@Autowired
	private UsuariosAyuntamientoDao usuariosAyuntamientoDao;

	@Autowired
	private AyuntamientosDao ayuntamientosDao;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

	@Autowired
	private UnidadesBaseService unidadesBaseService;

	/**
	 * Inserts a single row in the UsuariosAyuntamiento table.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 *
	 * @return UsuariosAyuntamiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public UsuariosAyuntamiento add(UsuariosAyuntamiento usuariosAyuntamiento) {
		usuariosAyuntamiento.setUsuAlta81(UtilSeguridad.getUsuarioConectado().getUserName());
		usuariosAyuntamiento.setfAlta81(UtilidadesFecha.getFechaSistema());

		if (TipoUsuarioEnum.AYUNTAMIENTO.getId().equals(usuariosAyuntamiento.getTipoUsuario())) {
			// Crear en usuario_ayuntamiento de ayuntamiento
			this.usuariosAyuntamientoDao.add(usuariosAyuntamiento);
		} else if (TipoUsuarioEnum.MANCOMUNIDAD.getId().equals(usuariosAyuntamiento.getTipoUsuario())) {
			// Crear en usuario_ayuntamiento de mancomunidad

			// Se buscan los ayuntamientos relacionados con la mancomunidad
			Ayuntamientos ayuntamientos = new Ayuntamientos();
			ayuntamientos.setMancomunidades(usuariosAyuntamiento.getAyuntamientos().getMancomunidades());
			List<Ayuntamientos> listaAyuntamientos = this.ayuntamientosDao.findAllLike(ayuntamientos, null, false);

			if (listaAyuntamientos.isEmpty()) {
				ManagerErrors
						.manageError(UtilLiterales.getLiteralMessage(appMessageSource, "error.user.noHayMancomunidad"));
			}

			// Se crean los registros
			for (Ayuntamientos ayuntamientosAux : listaAyuntamientos) {
				usuariosAyuntamiento.setAyuntamientos(ayuntamientosAux);
				this.usuariosAyuntamientoDao.add(usuariosAyuntamiento);
			}
		}
		return usuariosAyuntamiento;
	}

	/**
	 * Updates a single row in the UsuariosAyuntamiento table.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 *
	 * @return UsuariosAyuntamiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public UsuariosAyuntamiento update(UsuariosAyuntamiento usuariosAyuntamiento) {
		return this.usuariosAyuntamientoDao.update(usuariosAyuntamiento);
	}

	/**
	 * Finds a single row in the UsuariosAyuntamiento table.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 *
	 * @return UsuariosAyuntamiento
	 */
	public UsuariosAyuntamiento find(UsuariosAyuntamiento usuariosAyuntamiento) {
		return (UsuariosAyuntamiento) this.usuariosAyuntamientoDao.find(usuariosAyuntamiento);
	}

	public UsuariosAyuntamiento obtenerDatosUsuarioAyuntamiento(UsuariosAyuntamiento usuariosAyuntamiento) {

		UsuariosAyuntamiento usuAyunta = (UsuariosAyuntamiento) this.usuariosAyuntamientoDao.find(usuariosAyuntamiento);

		UnidadesBase ub = new UnidadesBase();
		ub.setIdMunicipio92(usuAyunta.getAyuntamientos().getMunicipio().getCodMunicipio());
		ub.setIdProvincia92(usuAyunta.getAyuntamientos().getProvincia().getCodProvincia());
		usuAyunta.getAyuntamientos().setUnidadesBase(this.unidadesBaseService.findAllLike(ub, null, false));

		return usuAyunta;
	}

	/**
	 * Deletes a single row in the UsuariosAyuntamiento table.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(UsuariosAyuntamiento usuariosAyuntamiento) {
		this.usuariosAyuntamientoDao.remove(usuariosAyuntamiento);
	}

	/**
	 * Finds a list of rows in the UsuariosAyuntamiento table.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto      TableRequestDto
	 *
	 * @return List<UsuariosAyuntamiento>
	 */
	public List<UsuariosAyuntamiento> findAll(UsuariosAyuntamiento usuariosAyuntamiento,
			TableRequestDto tableRequestDto) {
		return (List<UsuariosAyuntamiento>) this.usuariosAyuntamientoDao.findAll(usuariosAyuntamiento, tableRequestDto);
	}

	/**
	 * Finds rows in the UsuariosAyuntamiento table using like.
	 *
	 * @param usuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto      TableRequestDto
	 * @param startsWith           Boolean
	 * 
	 * @return List<UsuariosAyuntamiento>
	 */
	public List<UsuariosAyuntamiento> findAllLike(UsuariosAyuntamiento usuariosAyuntamiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return (List<UsuariosAyuntamiento>) this.usuariosAyuntamientoDao.findAllLike(usuariosAyuntamiento,
				tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the UsuariosAyuntamiento table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.usuariosAyuntamientoDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the UsuariosAyuntamiento table.
	 *
	 * @param filterUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto            TableRequestDto
	 * @param startsWith                 Boolean
	 *
	 * @return TableResponseDto<UsuariosAyuntamiento>
	 */
	public TableResponseDto<UsuariosAyuntamiento> filter(UsuariosAyuntamiento filterUsuariosAyuntamiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<UsuariosAyuntamiento> listaUsuariosAyuntamiento = this.usuariosAyuntamientoDao
				.findAllLike(filterUsuariosAyuntamiento, tableRequestDto, false);
//		for (UsuariosAyuntamiento usuAyunta : listaUsuariosAyuntamiento) {
//			// llamar a unidadesBaseController, a una función que devuelva una lista con las
//			// unidades base asociadas a cada ayuntamiento dentro de usuAyunta
//			UnidadesBase ub = new UnidadesBase();
//			ub.setIdMunicipio92(usuAyunta.getAyuntamientos().getMunicipio().getCodMunicipio());
//			ub.setIdProvincia92(usuAyunta.getAyuntamientos().getProvincia().getCodProvincia());
//			ub.setIdUsuarioAyuntamiento(usuAyunta.getUsuarios().getIdUsuario80());
//			ub.setBaja92("0");
//			usuAyunta.getAyuntamientos().setUnidadesBase(this.unidadesBaseService.findAllLikeRelacion(ub, null, false));
//		}
		Long recordNum = this.usuariosAyuntamientoDao.findAllLikeCount(
				filterUsuariosAyuntamiento != null ? filterUsuariosAyuntamiento : new UsuariosAyuntamiento(), false);
		TableResponseDto<UsuariosAyuntamiento> tableResponseDto = new TableResponseDto<UsuariosAyuntamiento>(
				tableRequestDto, recordNum, listaUsuariosAyuntamiento);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null
				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			List<TableRowDto<UsuariosAyuntamiento>> reorderSelection = this.usuariosAyuntamientoDao
					.reorderSelection(filterUsuariosAyuntamiento, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<UsuariosAyuntamiento>> reorderSeeker = this.usuariosAyuntamientoDao
					.reorderSelection(filterUsuariosAyuntamiento, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the UsuariosAyuntamiento table.
	 *
	 * @param filterUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param searchUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto            TableRequestDto
	 * @param startsWith                 Boolean
	 *
	 * @return List<TableRowDto<UsuariosAyuntamiento>>
	 */
	public List<TableRowDto<UsuariosAyuntamiento>> search(UsuariosAyuntamiento filterUsuariosAyuntamiento,
			UsuariosAyuntamiento searchUsuariosAyuntamiento, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.usuariosAyuntamientoDao.search(filterUsuariosAyuntamiento, searchUsuariosAyuntamiento,
				tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in UsuariosAyuntamiento table.
	 *
	 * @param filterUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto            TableRequestDto
	 * @param startsWith                 Boolean
	 *
	 * @return Object
	 */
	public Object reorderSelection(UsuariosAyuntamiento filterUsuariosAyuntamiento, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.usuariosAyuntamientoDao.reorderSelection(filterUsuariosAyuntamiento, tableRequestDto, startsWith);
	}

	@Transactional(rollbackFor = Throwable.class)
	public List<UsuariosAyuntamiento> getMultiple(UsuariosAyuntamiento filterUsuariosAyuntamiento,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.usuariosAyuntamientoDao.getMultiple(filterUsuariosAyuntamiento, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param columns                    String[]
	 * @param columnsName                String[]
	 * @param fileName                   String
	 * @param sheetTitle                 String
	 * @param reportsParams              ArrayList<?>
	 * @param tableRequestDto            TableRequestDto
	 * @param request                    HttpServletRequest
	 * @param response                   HttpServletResponse
	 */
	@Override
	public void generateReport(UsuariosAyuntamiento filterUsuariosAyuntamiento, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, ArrayList<?> reportsParams, TableRequestDto tableRequestDto,
			HttpServletRequest request, HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<UsuariosAyuntamiento> filteredData = getDataForReports(filterUsuariosAyuntamiento, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle
				: UsuariosAyuntamiento.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = UsuariosAyuntamiento.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					UsuariosAyuntamiento.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// Si no se definen los nombres de las columnas se dejan las definidas por
		// defecto
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<UsuariosAyuntamiento>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<UsuariosAyuntamiento> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(
						UtilLiterales.getLiteralMessage(appMessageSource, "excelReportLiteral." + columnsName[i]));
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (UsuariosAyuntamiento rowUsuariosAyuntamiento : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellUsuariosAyuntamiento = row.createCell(cellNumber++);
					cellUsuariosAyuntamiento.setCellValue(getCellValue(column, rowUsuariosAyuntamiento));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<UsuariosAyuntamiento>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<UsuariosAyuntamiento> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (UsuariosAyuntamiento rowUsuariosAyuntamiento : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowUsuariosAyuntamiento));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<UsuariosAyuntamiento>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<UsuariosAyuntamiento> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (UsuariosAyuntamiento rowUsuariosAyuntamiento : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowUsuariosAyuntamiento));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<UsuariosAyuntamiento>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<UsuariosAyuntamiento> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (UsuariosAyuntamiento rowUsuariosAyuntamiento : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowUsuariosAyuntamiento);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterUsuariosAyuntamiento UsuariosAyuntamiento
	 * @param tableRequestDto            TableRequestDto
	 *
	 * @return List<UsuariosAyuntamiento>
	 */
	public List<UsuariosAyuntamiento> getDataForReports(UsuariosAyuntamiento filterUsuariosAyuntamiento,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterUsuariosAyuntamiento != null) {
				return this.usuariosAyuntamientoDao.findAllLikeExcel(filterUsuariosAyuntamiento, tableRequestDto,
						false);
			} else {
				return this.usuariosAyuntamientoDao.findAllLikeExcel(filterUsuariosAyuntamiento, tableRequestDto,
						false);
			}
		} else {
			return this.usuariosAyuntamientoDao.findAllLikeExcel(filterUsuariosAyuntamiento, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column                  String
	 * @param rowUsuariosAyuntamiento UsuariosAyuntamiento
	 *
	 * @return String
	 */
	private String getCellValue(String column, UsuariosAyuntamiento rowUsuariosAyuntamiento) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowUsuariosAyuntamiento, column) != null
					? BeanUtils.getProperty(rowUsuariosAyuntamiento, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}
}
